#define MOTOR_PWM 11
#define MOTOR_DIR 12
#define INVERT_ONE_MOTOR_CHANNEL 1

#define ANALOG_PIN 0

#include "WProgram.h"
void setup();
void loop();
void setMotor(int s);
void setup() {
  pinMode(MOTOR_PWM, OUTPUT);
  pinMode(MOTOR_DIR, OUTPUT);
  Serial.begin(9600);  
}

int val=0;

void loop() {
  int key;
  
  key = Serial.read();
  if (key != -1)
  {
    switch (key)
    {
      case '+':
        val+=5;
        break;
        
      case '-':
        val-=5;
        break;
    }
  }
  
  if (val < -255)
    val = -255;
  if (val > 255)
    val = 255;
  
  setMotor(val);
  
  Serial.println(val);
  delay(20);
}

void setMotor(int s)
{
    
  if (s < 0)
  {
    s = -s;
    if (INVERT_ONE_MOTOR_CHANNEL)
      digitalWrite(MOTOR_DIR, LOW);
    else
      digitalWrite(MOTOR_DIR, HIGH);
      
    analogWrite(MOTOR_PWM, 255-s);
  }
  else
  {
    if (INVERT_ONE_MOTOR_CHANNEL)
      digitalWrite(MOTOR_DIR, HIGH);
    else
      digitalWrite(MOTOR_DIR, LOW);
      
    analogWrite(MOTOR_PWM, s);
  }
}
  
  
  

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

