#include "WProgram.h"
void setup();
void loop();
void servo(int pin, int len);
void myDelayMicroseconds(int len);
int servoPin = 13;
int potPin = 0;

void setup() {
  pinMode(servoPin,OUTPUT);
  Serial.begin(9600);        // use the serial port to send the values back to the computer
}


int val = 500;

void loop() {
  int key;
  key = Serial.read();
  if (key !=  -1)
  {
    if (key >= '0' && key <= '9')
    {
      val = (1000.0*(key-'0'))/9.0;
    }      
    Serial.println(val);           // print the value to the serial port
  }
  servo(servoPin, val);
}

void servo(int pin, int len) {
  digitalWrite(pin, HIGH);
  delayMicroseconds(590);
  myDelayMicroseconds(len);
  digitalWrite(pin, LOW);
  delay(10);
}

// delayMicroseconds hat einen seltsamen bug wenn man sie mit 0 aufruft
void myDelayMicroseconds(int len) {
  if (len != 0) {
    delayMicroseconds(len);
  }
}
  
  
  

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

